/* $Id: util.c 16 2023-03-01 02:12:34Z nishi $ */
#include <nikkel/util.h>

#include <stdlib.h>
#include <stddef.h>
#include <stdbool.h>
#include <time.h>

char* sstrdup(const char* str){
	char* result = malloc(sstrlen(str) + 1);
	result[sstrlen(str)] = 0;
	sstrcpy(result, str);
	return result;
}

char* sstrcat(const char* str1, const char* str2){
	char* result = malloc(sstrlen(str1) + sstrlen(str2) + 1);
	sstrcpy(result, str1);
	sstrcpy(result + sstrlen(str1), str2);
	return result;
}

char* sstrcat3(const char* str1, const char* str2, const char* str3){
	char* tmp = sstrcat(str1, str2);
	char* result = sstrcat(tmp, str3);
	free(tmp);
	return result;
}

char* sstrcat4(const char* str1, const char* str2, const char* str3, const char* str4){
	char* tmp = sstrcat3(str1, str2, str3);
	char* result = sstrcat(tmp, str4);
	free(tmp);
	return result;
}

char* sstrcat5(const char* str1, const char* str2, const char* str3, const char* str4, const char* str5){
	char* tmp = sstrcat4(str1, str2, str3, str4);
	char* result = sstrcat(tmp, str5);
	free(tmp);
	return result;
}

size_t sstrlen(const char* str){
	size_t result;
	for(result = 0; str[result] != 0; result++);
	return result;
}

void sstrcpy(char* dest, const char* src){
	size_t i;
	for(i = 0; src[i] != 0; i++) dest[i] = src[i];
	dest[i] = 0;
}

char* sreplace(const char* target, char from, char to){
	size_t i;
	char* result = sstrdup(target);
	for(i = 0; result[i]; i++){
		if(result[i] == from) result[i] = to;
	}
	return result;
}

bool sstartswith(const char* target, const char* starts_with){
	if(sstrlen(starts_with) > sstrlen(target)) return false;
	int i;
	for(i = 0; starts_with[i] != 0; i++){
		if(starts_with[i] != target[i]) return false;
	}
	return true;
}

size_t sindexof(const char* target, const char* find){
	size_t i;
	for(i = 0; target[i] != 0; i++){
		size_t j;
		for(j = 0; find[j]; j++){
			if(target[i] == find[j]) return i;
		}
	}
	return -1;
}

char* nikkel_date(){
	char* date = malloc(128);
	time_t t = time(NULL);
	struct tm *time_st = localtime(&t);
	strftime(date, 128, "%a %b %e %H:%M:%S %Z %Y", time_st);
	return date;
}
